<template>
    <div class="field">
        <label class="label" v-if="!hideLabel" :for="field">{{ label }}
            <div class="is-pulled-right text-is-smaller is-hoverable">
                <b-tooltip v-if="helpText" type="is-dark" :label="helpText" multilined position="is-left">
                    <svg class="icon is-small has-text-grey">
                        <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#help"></use>
                    </svg>
                </b-tooltip>
            </div>
            <transition name="fade-scale">
                <small class="text-is-primary text-is-smaller is-pulled-right" v-if="isRequired">Required &nbsp; </small>
            </transition>
        </label>
        <p class="control is-fullwidth" :class="{'select':isSelect,'box':helpText && hideLabel}">
            <slot></slot>
            <b-tooltip v-if="helpText && hideLabel" type="is-dark" :label="helpText" multilined position="is-left" class="is-pulled-right text-is-smaller is-hoverable">
                <svg class="icon is-small has-text-grey">
                    <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#help"></use>
                </svg>
            </b-tooltip>
        </p>
        <transition name="slide-fade">
            <p class="help is-danger" v-if="form.errors.has(field)">{{ form.errors.get(field) }}</p>
        </transition>
    </div>
</template>

<script>
    import BTooltip from 'buefy/src/components/tooltip';
    export default {
        components:{BTooltip},
        props: {
            field:String,
            label:String,
            form: {
                type: Object,
                default: () => {
                    return {errors:{ get() {}, has() {} } }
                }
            },
            hideLabel: Boolean,
            isSelect:Boolean,
            isRequired:Boolean,
            helpText:String
        }
    }
</script>
